package org.dataone.tidy.merge;

import java.io.IOException;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import org.dataone.cn.dao.exceptions.DataAccessException;
import org.dataone.service.types.v1.Identifier;
import org.dataone.service.types.v1.NodeReference;
import org.dataone.service.types.v1.SystemMetadata;
import org.dataone.service.util.TypeMarshaller;
import org.dataone.tidy.dao.SystemMetadataTidyDao;
import org.jibx.runtime.JiBXException;

public class MockFailSaveSystemMetadataTidyDaoImpl implements SystemMetadataTidyDao {

	private SystemMetadata resultingSysmeta;


	@Override
	public List<Identifier> listIdentifiers() throws DataAccessException {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public Map<NodeReference, SystemMetadata> getSystemMetadata(
			Identifier identifier) throws DataAccessException {
		Map<NodeReference, SystemMetadata> map = new LinkedHashMap<NodeReference,SystemMetadata>();
		NodeReference nr1 = new NodeReference();
		nr1.setValue("urn:node:cnORC");
		NodeReference nr2 = new NodeReference();
		nr2.setValue("urn:node:cnUNM");
		NodeReference nr3 = new NodeReference();
		nr3.setValue("urn:node:cnUCSB");
		try {
			map.put(nr1, getSysmetaResource("strategy/replicationAllowed/sysmeta_asc.xml"));
			map.put(nr2, getSysmetaResource("strategy/replicationAllowed/sysmeta_nonAsc_1.xml"));
			map.put(nr3, getSysmetaResource("strategy/replicationAllowed/sysmeta_nonAsc_2.xml"));
		} catch (IOException e) {
			throw new DataAccessException(e);
		} catch (InstantiationException e) {
			throw new DataAccessException(e);
		} catch (IllegalAccessException e) {
			throw new DataAccessException(e);
		} catch (JiBXException e) {
			throw new DataAccessException(e);
		}
		return map;
	}

    private SystemMetadata getSysmetaResource(String file) 
    throws IOException, InstantiationException, IllegalAccessException, JiBXException 
    {
    	return TypeMarshaller.unmarshalTypeFromStream(SystemMetadata.class,
    			this.getClass().getResourceAsStream(file));
    }

	
	@Override
	public void saveSystemMetadata(SystemMetadata systemMetadata)
			throws DataAccessException {
		Throwable t = new Exception("a test fail at save-time");
		throw new DataAccessException(t);

	}
	
	public SystemMetadata getSavedResultingSysmeta() {
		return this.resultingSysmeta;
	}

}
